<?php
/* Autor...:  */
/* Esquema.: FCO_Caja.xml */
/* Generado: 2020-08-18 04:21:25 */

/* Metodos de acceso a los campos de la tabla FCO_Caja */
abstract class BaseFCO_CajaBN
{
    /* Campos de la tabla */
    private $i_IdCaja;    // IdCaja: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_Descripcion;    // Descripcion: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdCaja */
    public function setIdCaja( $i_IdCaja )
    {
        $this->i_IdCaja = $i_IdCaja;
    }

    /* Obtiene el valor del campo IdCaja */
    public function getIdCaja()
    {
        return $this->i_IdCaja;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo Descripcion */
    public function setDescripcion( $s_Descripcion )
    {
        $this->s_Descripcion = $s_Descripcion;
    }

    /* Obtiene el valor del campo Descripcion */
    public function getDescripcion()
    {
        return $this->s_Descripcion;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdCaja' => $this->getIdCaja(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'Descripcion' => $this->getDescripcion(),
            'Estado' => $this->getEstado(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto FCO_CajaBN desde un RecordSet */
    public static function retrieveByRs( $o_FCO_CajaRs )
    {
        $o_FCO_CajaBN = new FCO_CajaBN();
        $o_FCO_CajaBN->setIdCaja( ( integer ) $o_FCO_CajaRs[ "IdCaja" ] );
        $o_FCO_CajaBN->setIdCompania( ( integer ) $o_FCO_CajaRs[ "IdCompania" ] );
        $o_FCO_CajaBN->setIdSucursal( ( integer ) $o_FCO_CajaRs[ "IdSucursal" ] );
        $o_FCO_CajaBN->setDescripcion( $o_FCO_CajaRs[ "Descripcion" ] );
        $o_FCO_CajaBN->setEstado( $o_FCO_CajaRs[ "Estado" ] );
        $o_FCO_CajaBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_FCO_CajaRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_FCO_CajaBN->setUsuarioCreacion( $o_FCO_CajaRs[ "UsuarioCreacion" ] );
        $o_FCO_CajaBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_FCO_CajaRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_FCO_CajaBN->setUsuarioModificacion( $o_FCO_CajaRs[ "UsuarioModificacion" ] );
        return $o_FCO_CajaBN;
    }
}
?>